﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace TeacheresAndCourses.Models;

public partial class _43pSuharevaContext : DbContext
{
    public _43pSuharevaContext()
    {
    }

    public _43pSuharevaContext(DbContextOptions<_43pSuharevaContext> options)
        : base(options)
    {
    }

    public virtual DbSet<Course> Courses { get; set; }

    public virtual DbSet<Gender> Genders { get; set; }

    public virtual DbSet<Subject> Subjects { get; set; }

    public virtual DbSet<Teacher> Teachers { get; set; }

    public virtual DbSet<TeachersAndCourse> TeachersAndCourses { get; set; }

    public virtual DbSet<TeachersAndSubject> TeachersAndSubjects { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see https://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.ru;Port=5442;Database=43P_Suhareva;Username=43P;Password=444444");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<Course>(entity =>
        {
            entity.HasKey(e => e.Courseid).HasName("courses_pkey");

            entity.ToTable("courses");

            entity.Property(e => e.Courseid)
                .UseIdentityAlwaysColumn()
                .HasColumnName("courseid");
            entity.Property(e => e.Title)
                .HasMaxLength(150)
                .HasColumnName("title");
        });

        modelBuilder.Entity<Gender>(entity =>
        {
            entity.HasKey(e => e.Genderid).HasName("genders_pkey");

            entity.ToTable("genders");

            entity.Property(e => e.Genderid)
                .UseIdentityAlwaysColumn()
                .HasColumnName("genderid");
            entity.Property(e => e.Title)
                .HasMaxLength(50)
                .HasColumnName("title");
        });

        modelBuilder.Entity<Subject>(entity =>
        {
            entity.HasKey(e => e.Subjectid).HasName("subjects_pkey");

            entity.ToTable("subjects");

            entity.Property(e => e.Subjectid)
                .UseIdentityAlwaysColumn()
                .HasColumnName("subjectid");
            entity.Property(e => e.Title)
                .HasMaxLength(150)
                .HasColumnName("title");
        });

        modelBuilder.Entity<Teacher>(entity =>
        {
            entity.HasKey(e => e.Teacherid).HasName("teachers_pkey");

            entity.ToTable("teachers");

            entity.Property(e => e.Teacherid)
                .UseIdentityAlwaysColumn()
                .HasColumnName("teacherid");
            entity.Property(e => e.Birthday)
                .HasColumnType("timestamp without time zone")
                .HasColumnName("birthday");
            entity.Property(e => e.Email)
                .HasMaxLength(50)
                .HasColumnName("email");
            entity.Property(e => e.ExperienceInMonth).HasColumnName("experience in month");
            entity.Property(e => e.Firstname)
                .HasMaxLength(50)
                .HasColumnName("firstname");
            entity.Property(e => e.Gender).HasColumnName("gender");
            entity.Property(e => e.Lastname)
                .HasMaxLength(50)
                .HasColumnName("lastname");
            entity.Property(e => e.Patronymic)
                .HasMaxLength(50)
                .HasColumnName("patronymic");
            entity.Property(e => e.PhoneNumber)
                .HasMaxLength(50)
                .HasColumnName("phone number");

            entity.HasOne(d => d.GenderNavigation).WithMany(p => p.Teachers)
                .HasForeignKey(d => d.Gender)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("teachers_gender_fkey");
        });

        modelBuilder.Entity<TeachersAndCourse>(entity =>
        {
            entity.HasKey(e => e.TeacherAndCoursesId).HasName("teachers and courses_pkey");

            entity.ToTable("teachers and courses");

            entity.Property(e => e.TeacherAndCoursesId)
                .UseIdentityAlwaysColumn()
                .HasColumnName("teacher and courses ID");
            entity.Property(e => e.Courseid).HasColumnName("courseid");
            entity.Property(e => e.Teacherid).HasColumnName("teacherid");

            entity.HasOne(d => d.Course).WithMany(p => p.TeachersAndCourses)
                .HasForeignKey(d => d.Courseid)
                .HasConstraintName("teachers and courses_courseid_fkey");

            entity.HasOne(d => d.Teacher).WithMany(p => p.TeachersAndCourses)
                .HasForeignKey(d => d.Teacherid)
                .HasConstraintName("teachers and courses_teacherid_fkey");
        });

        modelBuilder.Entity<TeachersAndSubject>(entity =>
        {
            entity.HasKey(e => e.TeacherAndSubjectId).HasName("teachers and subjects_pkey");

            entity.ToTable("teachers and subjects");

            entity.Property(e => e.TeacherAndSubjectId)
                .UseIdentityAlwaysColumn()
                .HasColumnName("teacher and subject ID");
            entity.Property(e => e.Subjectid).HasColumnName("subjectid");
            entity.Property(e => e.Teacherid).HasColumnName("teacherid");

            entity.HasOne(d => d.Subject).WithMany(p => p.TeachersAndSubjects)
                .HasForeignKey(d => d.Subjectid)
                .HasConstraintName("teachers and subjects_subjectid_fkey");

            entity.HasOne(d => d.Teacher).WithMany(p => p.TeachersAndSubjects)
                .HasForeignKey(d => d.Teacherid)
                .HasConstraintName("teachers and subjects_teacherid_fkey");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
